%{
  Soluzione di una rete lineare. In questo programma NON si utilizzano gli
  strumenti "Graph and Networks Algorithms" di Matlab (visualizzazione a
  parte)
%}
clear all
clc
close all

% Large number
bigg = 1/eps(1)/1e5;

% Tabella connessione nodi-rami
T = [1 2;2 3;3 4;4 1;2 4];

% Numero nodi e rami
N = max(T(:));
M = size(T,1);

% Resistenze rami
R = [0.1;0.2;0.12;0.3;0.5];

% Potenziale imposto ai nodi
Phi0 = [0;nan;nan;nan];

% Corrente estratta dai nodi (non viene utilizzato per i nodi a potenziale imposto);
In = [0;0;1;1.3];

% Matrice di connettivit
C = sparse(M,N);
C(sub2ind([M,N],[1:M]',T(:,1))) =  1;
C(sub2ind([M,N],[1:M]',T(:,2))) = -1;

% Matrice coefficienti
A = (C'*spdiags(1./R,0,M,M))*C;

% Vettore termini noti
b = -In;

% Imposto potenziale noto, ma prima salvo matrice non modificata
As = A;
nD = find(~isnan(Phi0));
A(sub2ind([N,N],nD,nD)) = bigg;
b(nD) = bigg*Phi0(nD);


% Calcolo
Phi = A\b;

% Corrente estratta da nodi Dirichlet
I = -As*Phi;

% Corrente nei rami
Ib = spdiags(1./R,0,M,M)*C*Phi;

% Plot graph
figure
G=digraph(T(:,1),T(:,2),Ib);
h=plot(G,'EdgeLabel',G.Edges.Weight,'NodeLabel',Phi);
set(h,'linewidth',2.0);