%{
  Soluzione di una rete lineare. In questo programma si utilizzano gli
  strumenti "Graph and Networks Algorithms" di Matlab.
%}
clear all
clc
close all

% Large number
bigg = 1/eps(1)/1e5;

% Nodi sorgente e target
s = [1 2 3 4 2]; 
t = [2 3 4 1 4];

% Resistenze rami
R = [0.1;0.2;0.12;0.3;0.5];

% Crea grafo orientato, usando come pesi per i rami le conduttanze
G = digraph(s,t,1./R);

% Numero nodi e rami
N = height(G.Nodes);
M = height(G.Edges);


% Potenziale imposto ai nodi
Phi0 = [0;nan;nan;nan];

% Corrente estratta dai nodi (non viene utilizzato per i nodi a potenziale imposto);
In = [0;0;1;1.3];

% Matrice di connettivit (ha convenzioni opposte sui segni rispetto a
% quelle che uso io....)
C = -incidence(G).';

% Matrice coefficienti
A = (C'*spdiags(G.Edges.Weight,0,M,M))*C;

% Vettore termini noti
b = -In;

% Imposto potenziale noto, ma prima salvo matrice non modificata
As = A;
nD = find(~isnan(Phi0));
A(sub2ind([N,N],nD,nD)) = bigg;
b(nD) = bigg*Phi0(nD);

% Calcolo
G.Nodes.Phi = A\b;

% Corrente estratta da nodi 
G.Nodes.Inode = -As*G.Nodes.Phi;

% Corrente nei rami
G.Edges.I = spdiags(G.Edges.Weight,0,M,M)*C*G.Nodes.Phi;

% Plot graph
figure
h=plot(G,'EdgeLabel',G.Edges.I,'NodeLabel',G.Nodes.Phi);
set(h,'linewidth',2.0);